/* global process */

process.env['DEBUG']='*';
//console.log(process);


var pkgInfo = require('./package.json');
//if (process.platform !== 'win32'){
var Service = require('webos-service');
//}else{ // Create a dummy Service object
//  var Service = function(){
//    var cbs = {};
//    this.register = function(funcName, cb){
//      console.log('Service registering ', funcName);
//    };
//  };
//}

var subscriptions = {};

var tasker;
try {
   tasker = require('./tasker');
} catch (e) {
  console.error(e);
  var stack = new Error().stack;
  
  var er = {e:e, stack : stack};
  
  tasker = {
    tick : function(){},
    getGlobalError:function(er){
      return er;
    }
  };
  
  //Reply to all subscribers
  var keys = Object.keys(subscriptions); 
  //console.log(subscriptions);
  for (var i in keys) {
    subscriptions[keys[i]].respond({
      returnValue : true,
      hb : "hb - " + heartbeat_count,
      error: er
    });
  }
  
}



var service = new Service(pkgInfo.name);

var heartbeat_count = 0;
var heartBeatTimer = undefined;
//
//service.register("init", function(message){
//  console.log("Init");
//  
//  message.respond({
//    returnValue : true,
//    message : "Initted"
//  });
//});

service.register("getError", 
  function(message){
    message.respond({
      returnValue : true,
      message : {
        'error' : tasker.getGlobalError()
      }
    });
  }
);

service.register("heartbeat", 
  function(message){
    console.log("heartbeat");
    if (message.isSubscription) { 
      subscriptions[message.uniqueToken] = message;
    }
//    message.respond({
//      returnValue : true,
//      message : "hb subscribed"
//    });
  },
  function(message){//Cancel Handler
    //console.log('Cancel Heartbeat', JSON.stringify(message));
    delete subscriptions[message.uniqueToken];
    var keys = Object.keys(subscriptions); 
    if (keys.length === 0) { 
      console.log('Empty subscribers list. What to do;');
      if (heartBeatTimer){
        clearInterval(heartBeatTimer);
        heartBeatTimer = undefined;
      }
    }
  }
);


var issue_hearbeat = function(){
  heartbeat_count++;
//  console.info('HB ' + heartbeat_count);
  tasker.tick();
  try {
    var keys = Object.keys(subscriptions); 
    //console.log(subscriptions);
    for (var i in keys) {
      subscriptions[keys[i]].respond({
        returnValue : true,
        hb : "hb - " + heartbeat_count
      });
    }
    
  } catch (e) {
    console.warn('Error' , e);
  }
};
heartBeatTimer = setInterval(issue_hearbeat, 5000);
  
issue_hearbeat();
  //module.exports = require('./tasker');