"use strict";var Logger=new function(){var t,e="logs",o="stats",n=Object.create(null);Object.defineProperty(n,"AUDIT",{enumerable:!1,configurable:!1,writable:!1,value:"audit"}),Object.defineProperty(n,"ERROR",{enumerable:!1,configurable:!1,writable:!1,value:"error"});var r=!1,a=!1,i=0,s=0;function c(o,r){if(o!==n.ERROR&&o!==n.AUDIT)throw new TypeError("Category must be 'error' or 'audit'");if(!defined(r))throw new TypeError("Message must be set!");this.date=utils.getISODate(),this.category=o,this.message=r,this.onlyOnce=!1,this.constructor.prototype.toElement=function(){var t=document.implementation.createDocument(null,"l",null),e=t.createElement("log");e.setAttribute("date",this.date),e.setAttribute("category",this.category);var o=t.createElement("message");if(o.textContent=this.message,e.appendChild(o),void 0!==this.scheduleID){var n=t.createElement("scheduleID");n.textContent=this.scheduleID,e.appendChild(n)}if(void 0!==this.layoutID){var r=t.createElement("layoutID");r.textContent=this.layoutID,e.appendChild(r)}if(void 0!==this.mediaID){var a=t.createElement("mediaID");a.textContent=this.mediaID,e.appendChild(a)}if(void 0!==this.type){var i=t.createElement("type");i.textContent=this.type,e.appendChild(i)}if(void 0!==this.method){var s=t.createElement("method");s.textContent=this.method,e.appendChild(s)}if(void 0!==this.thread){var c=t.createElement("thread");c.textContent=this.thread,e.appendChild(c)}return e},this.constructor.prototype.equals=function(t){for(var e=["category","message","method","thread","type","scheduleID","layoutID","mediaID"],o=0,n=e.length;o<n;o++)if(this[e[o]]!==t[e[o]])return!1;return!0},this.constructor.prototype.exists=function(o,n){var r=t.transaction([e],"readonly").objectStore(e).openCursor(),a=this;r.onerror=function(t){console.error(t),n&&n(t)},r.onsuccess=function(t){var e=t.target.result;if(e){var n=e.value;a.equals(n)?o(!0):e.continue()}else if(o)return void o(!1)}}}this.cmsLog=function(o,n,r){defined(o)||console.error("CMS log entry not defined!"),o.hasOwnProperty("category")||console.error("CMS log entry has no category defined!"),o.hasOwnProperty("message")||console.error("CMS log entry has no message defined!");var a=new c(o.category,o.message);o.hasOwnProperty("scheduleID")&&(a.scheduleID=o.scheduleID),o.hasOwnProperty("layoutID")&&(a.layoutID=o.layoutID),o.hasOwnProperty("mediaID")&&(a.mediaID=o.mediaID),o.hasOwnProperty("type")&&(a.type=o.type),o.hasOwnProperty("method")&&(a.method=o.method),o.hasOwnProperty("thread")&&(a.thread=o.thread),o.hasOwnProperty("onlyOnce")&&(a.onlyOnce=o.onlyOnce);var s=function(o){var a=t.transaction([e],"readwrite");a.onerror=function(){console.error("Error adding log",a.error)};var s=a.objectStore(e).add(o);s.onsuccess=function(){i+=1,application.statusPage.backlogLogsCount(i),n&&n()},s.onerror=function(t){console.debug("Log add failed",t),r&&r(t)}},u=function(){a.onlyOnce?a.exists(function(t){t||s(a)},function(t){throw t}):s(a)};switch(WebOSManager.Config.getLogLevel()){case"error":"error"===a.category&&u();break;case"audit":u()}application.statusPage.addLogMessage(a)},Object.defineProperty(this.cmsLog,"CATEGORY",{enumerable:!1,configurable:!1,writable:!1,value:n}),this.submitLog=function(o,n){var a=!1,s=function(){console.debug("sendLogs with backlog",r);var t=document.implementation.createDocument(null,"logs",null),e=50;Logger.countLogs(function(u){if(0===u)return r=!1,void(!a&&o&&o());u>500&&(r=!0),r&&(e=300),Logger.getAllLogKeys(function(u){var l=u[0],d=u[u.length-1];Logger.getAllLogs(function(e){for(var u=0;u<e.length;u++){var g=Object.create(c.prototype),f=Object.assign(g,e[u]);t.firstChild.appendChild(f.toElement())}var h=(new XMLSerializer).serializeToString(t);CommunicationManager.sendLog(function(){application.statusPage.backlogLogsDate(utils.getISODate()),Logger.removeSpecificLogs(function(){i-=e.length,application.statusPage.backlogLogsCount(i),r&&setTimeout(s,3e4),a||(a=!0,o&&o())},function(t){r=!1,n&&n(t)},IDBKeyRange.bound(l,d))},function(t){r=!1,n&&n(t)},h)},function(t){console.error(t),r=!1,n&&n(t)},e)},function(t){r=!1,n&&n(t)},e)},function(t){r=!1,n&&n(t)})},u=t.transaction([e],"readonly").objectStore(e).count();u.onsuccess=function(t){if(u.result>0)s();else if(r=!1,o)return void o()},u.onerror=function(t){console.error(t),n&&n(t)}},this.logStat=function(e,n,r){if(WebOSManager.Config.getOptions().hasOwnProperty("statsEnabled")&&0!=WebOSManager.Config.getOptions().statsEnabled){defined(e)||console.error("Statistic not defined!"),e.hasOwnProperty("layoutid")||console.error("No layout id defined!"),e.hasOwnProperty("fromdt")||console.error("No from date defined!"),e.hasOwnProperty("todt")||console.error("No to date defined!"),e.hasOwnProperty("scheduleid")||console.error("No schedule id defined!"),e.hasOwnProperty("mediaid")?e.type="media":e.type="layout";var a=t.transaction([o],"readwrite");a.onerror=function(t){console.error("Error adding stat",a.error)};var i=a.objectStore(o).add(e);i.onsuccess=function(t){s+=1,application.statusPage.backlogStatsCount(s),n&&n()},i.onerror=function(t){console.debug("Stat add failed",t),r&&r()}}},this.submitStats=function(e,n){var r=!1,i=t.transaction([o],"readwrite"),c=function(){console.debug("Individual (before check) with backlog",a);var t=document.implementation.createDocument(null,"stats",null),o=50;Logger.countStats(function(i){if(0===i)return a=!1,void(!r&&e&&e());i>500&&(a=!0),a&&(o=300),Logger.getAllStatKeys(function(i){var u=i[0],l=i[i.length-1];Logger.getAllStats(function(o){for(var i=0;i<o.length;i++){var d=t.createElement("stat");for(var g in o[i])d.setAttribute(g,o[i][g]);t.firstChild.appendChild(d)}var f=(new XMLSerializer).serializeToString(t);CommunicationManager.sendStats(function(){application.statusPage.backlogStatsDate(utils.getISODate()),Logger.removeSpecificStats(function(){s-=o.length,application.statusPage.backlogStatsCount(s),a&&setTimeout(c,3e4),r||(r=!0,e&&e())},function(t){a=!1,n&&n(t)},IDBKeyRange.bound(u,l))},function(t){a=!1,n&&n(t)},f)},function(t){a=!1,console.error(t),n&&n(t)},o)},function(t){a=!1,n&&n(t)},o)},function(t){a=!1,n&&n(t)})},u=function(){console.debug("Hourly (before check) with backlog",a);var i=50;Logger.countStats(function(c){if(0===c)return a=!1,void(!r&&e&&e());c>=3600&&(a=!0),a&&(i=300);var l=document.implementation.createDocument(null,"stats",null),d=t.transaction([o],"readwrite").objectStore(o).openCursor(),g={},f=new Date(utils.getISODate());f.setMinutes(0),f.setSeconds(0);var h=[];function p(t,e){if(f>=new Date(t.todt)&&(h.push(e),t.hasOwnProperty("layoutid")&&"splash"!==t.layoutid)){var o=t.todt.substr(0,13)+" "+t.mediaid+" "+t.layoutid+" "+t.scheduleid,n=t.fromdt,r=t.todt,a=t.duration;g[o]?(new Date(g[o].fromdt)>new Date(n)&&(g[o].fromdt=n),new Date(g[o].todt)<new Date(r)&&(g[o].todt=r),g[o].count++,g[o].duration+=a):(g[o]={fromdt:n,todt:r,layoutid:t.layoutid,scheduleid:t.scheduleid,type:t.type,count:1,duration:a},t.mediaid&&(g[o].mediaid=t.mediaid))}}d.onerror=function(t){console.error(t),n&&n(t)},d.onsuccess=function(t){var o=t.target.result;if(o&&Object.keys(g).length<i){for(var c=o.value,d=new Date(c.fromdt.slice(0,13)+":00:00"),f=new Date(1*d+36e5),m=Object.assign({},c),v=1e3;new Date(c.fromdt)<d&&(m.fromdt=utils.getISODate(d)),new Date(c.todt)>f&&(m.todt=utils.getISODate(f)),m.duration=(new Date(m.todt)-new Date(m.fromdt))/1e3,m.fromdt=utils.getISODate(d),m.todt=utils.getISODate(f),m.duration>0&&p(m,o.key),!(f>new Date(c.todt));){if(d=f,f=new Date(1*d+36e5),m=Object.assign({},c),0===v)throw new Error("Endless loop detected");v--}o.continue()}else if(Object.keys(g).length>0){for(var c in g){var b=l.createElement("stat");for(var y in g[c])b.setAttribute(y,g[c][y]);l.firstChild.appendChild(b)}var S=(new XMLSerializer).serializeToString(l);CommunicationManager.sendStats(function(){application.statusPage.backlogStatsDate(utils.getISODate());var t=h.length,o=IDBKeyRange.bound(h[0],h[h.length-1]);Logger.removeSpecificStats(function(){s-=t,application.statusPage.backlogStatsCount(s),a&&setTimeout(u,3e4),r||(r=!0,e&&e())},n,o)},n,S)}else if(a=!1,e)return void e()}},function(){n&&n(event)})},l=function(){console.debug("Daily (before check) with backlog",a);var i=50;Logger.countStats(function(c){if(0===c)return a=!1,void(!r&&e&&e());c>=3e3&&(a=!0),a&&(i=300),console.debug("Daily (after check) with backlog",a);var u=document.implementation.createDocument(null,"stats",null),d=t.transaction([o],"readonly").objectStore(o).openCursor(),g={},f=new Date(utils.getISODate());f.setHours(0),f.setMinutes(0),f.setSeconds(0);var h=[];function p(t,e){if(f>=new Date(t.todt)&&(h.push(e),t.hasOwnProperty("layoutid")&&"splash"!==t.layoutid)){var o=t.todt.substr(0,10)+" "+t.mediaid+" "+t.layoutid+" "+t.scheduleid,n=t.fromdt,r=t.todt,a=t.duration;g[o]?(new Date(g[o].fromdt)>new Date(n)&&(g[o].fromdt=n),new Date(g[o].todt)<new Date(r)&&(g[o].todt=r),g[o].count++,g[o].duration+=a):(g[o]={fromdt:n,todt:r,layoutid:t.layoutid,scheduleid:t.scheduleid,type:t.type,count:1,duration:a},t.mediaid&&(g[o].mediaid=t.mediaid))}}d.onerror=function(t){console.error(t),a=!1,n&&n(t)},d.onsuccess=function(t){var o=t.target.result;if(o&&Object.keys(g).length<i){for(var c=o.value,d=new Date(c.fromdt.slice(0,10)+" 00:00:00"),f=new Date(1*d+864e5),m=Object.assign({},c),v=1e3;new Date(c.fromdt)<d&&(m.fromdt=utils.getISODate(d)),new Date(c.todt)>f&&(m.todt=utils.getISODate(f)),m.duration=(new Date(m.todt)-new Date(m.fromdt))/1e3,m.fromdt=utils.getISODate(d),m.todt=utils.getISODate(f),m.duration>0&&p(m,o.key),!(f>new Date(c.todt));){if(d=f,f=new Date(1*d+864e5),m=Object.assign({},c),0===v)throw new Error("Endless loop detected");v--}o.continue()}else if(Object.keys(g).length>0){for(var c in g){var b=u.createElement("stat");for(var y in g[c])b.setAttribute(y,g[c][y]);u.firstChild.appendChild(b)}var S=(new XMLSerializer).serializeToString(u);CommunicationManager.sendStats(function(){application.statusPage.backlogStatsDate(utils.getISODate());var t=h.length,o=IDBKeyRange.bound(h[0],h[h.length-1]);Logger.removeSpecificStats(function(){s-=t,application.statusPage.backlogStatsCount(s),a&&setTimeout(l,3e4),r||(r=!0,e&&e())},function(t){a=!1,n&&n(t)},o)},function(t){a=!1,n&&n(t)},S)}else if(a=!1,e)return void e()}},function(){a=!1,n&&n(event)})},d=i.objectStore(o).count();d.onsuccess=function(t){if(d.result>0){if(a&&e)return void e();if(WebOSManager.Config.getOptions().hasOwnProperty("aggregationLevel"))switch(WebOSManager.Config.getOptions().aggregationLevel){case Logger.AGGREGATIONLEVEL_HOURLY:u();break;case Logger.AGGREGATIONLEVEL_DAILY:l();break;default:c()}else c()}else if(a=!1,e)return void e()},d.onerror=function(t){console.error(t),n&&n(t)}},this.getAllLogKeys=function(o,n,r){var a=t.transaction([e],"readwrite").objectStore(e).getAllKeys(void 0,r);a.onerror=function(t){console.error(t),n&&n(t)},a.onsuccess=function(t){o(t.target.result)}},this.getAllStatKeys=function(e,n,r){var a=t.transaction([o],"readwrite").objectStore(o).getAllKeys(void 0,r);a.onerror=function(t){console.error(t),n&&n(t)},a.onsuccess=function(t){e(t.target.result)}},this.getAllStats=function(e,n,r){var a=t.transaction([o],"readwrite").objectStore(o).getAll(void 0,r);a.onerror=function(t){console.error(t),n&&n(t)},a.onsuccess=function(t){e(t.target.result)}},this.getAllLogs=function(o,n,r){var a=t.transaction([e],"readwrite").objectStore(e).getAll(void 0,r);a.onerror=function(t){console.error(t),n&&n(t)},a.onsuccess=function(t){o(t.target.result)}},this.clearLogs=function(o,n){var r=t.transaction([e],"readwrite").objectStore(e).clear();r.onsuccess=function(t){application.statusPage.backlogLogsCount(0),i=0,o&&o()},r.onerror=function(t){n&&n(t)}},this.clearStats=function(e,n){var r=t.transaction([o],"readwrite").objectStore(o).clear();r.onsuccess=function(t){application.statusPage.backlogStatsCount(0),s=0,e&&e()},r.onerror=function(t){n&&n(t)}},this.removeSpecificStats=function(e,n,r){var a=t.transaction([o],"readwrite").objectStore(o).delete(r);a.onsuccess=function(){e&&e()},a.onerror=function(){n&&n()}},this.removeSpecificLogs=function(o,n,r){var a=t.transaction([e],"readwrite").objectStore(e).delete(r);a.onsuccess=function(){o&&o()},a.onerror=function(){n&&n()}},this.countStats=function(e,n){var r=t.transaction([o],"readwrite"),a=r.objectStore(o).count();r.onerror=function(){console.error("Error counting statistics",r.error),n(r.error)},a.onsuccess=function(){console.info("Stats count",a.result),application.statusPage&&application.statusPage.backlogStatsCount&&application.statusPage.backlogStatsCount(a.result),s=a.result,e&&e(a.result)},a.onerror=function(t){n&&n(t)}},this.countLogs=function(o,n){var r=t.transaction([e],"readwrite"),a=r.objectStore(e).count();r.onerror=function(){console.error("Error counting statistics",r.error),n(r.error)},a.onsuccess=function(){application.statusPage&&application.statusPage.backlogLogsCount&&application.statusPage.backlogLogsCount(a.result),i=a.result,o&&o(a.result)},a.onerror=function(t){n&&n(t)}},this.init=function(n,r){var a=3,i={},s=function(){--a>0?function(n,r){var a=window.indexedDB.open("xibo",1);a.onerror=function(t){console.error(t),r&&r(t)},a.onsuccess=function(e){console.debug("Database initialized!"),t=e.target.result,n&&n(t),Logger.countLogs(function(t){console.debug("Logs in db",t),Logger.countStats(function(t){console.debug("Stats in db",t)},function(t){console.error(t)})},function(t){console.error(t)})},a.onupgradeneeded=function(t){var n=t.target.result;n.onerror=function(t){console.error(t)},0===t.oldVersion&&(n.createObjectStore(e,{autoIncrement:!0}),n.createObjectStore(o,{autoIncrement:!0}))}}(n,function(t){for(var e in t)i[e]=t[e];setTimeout(s,1e3)}):r&&r(i)};s()},this.getIndexedDBInstance=function(){return t}};utils.const(Logger,"AGGREGATIONLEVEL_INDIVIDUAL","Individual"),utils.const(Logger,"AGGREGATIONLEVEL_HOURLY","Hourly"),utils.const(Logger,"AGGREGATIONLEVEL_DAILY","Daily"),utils.const(Logger,"LOGLEVEL_ERROR","error"),utils.const(Logger,"LOGLEVEL_AUDIT","audit");